#!/usr/bin/python3

# creates a node to call the dji service that activates main camera images
# TBD: also activate the usb connection from the drone to enable usb-connected flight
# this command: ./M210ConfigTool --usb-port /dev/ttyACM0 --config-file UserConfig.txt --usb-connected-flight on
import rospy
from dji_sdk.srv import StereoVGASubscription
from dji_sdk.srv import SetupCameraStream

def main():
    rospy.init_node('imageActivation')

    # request drone to open stereo images
    rospy.wait_for_service('/dji_sdk/setup_camera_stream')
    try:
        camera_service_proxy = rospy.ServiceProxy('/dji_sdk/setup_camera_stream', SetupCameraStream)
        response = camera_service_proxy(1, 1)
        rospy.loginfo(response)
    except:
        rospy.loginfo("image service call failed")

if __name__ == '__main__':
    main()
